package com.tptj.demo.hg.cell.value.provider;

import com.fr.base.Style;
import com.fr.intelli.record.Focus;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.report.cell.CellElement;
import com.fr.report.cell.cellattr.CellGUIAttr;
import com.fr.report.fun.impl.AbstractCellValueProvider;
import com.fr.stable.script.CalculatorProvider;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/6/9
 **/
@EnableMetrics
public class Demo extends AbstractCellValueProvider {
    @Override
    @Focus(id="com.tptj.demo.hg.cell.value.provider.v10",text = "CellValueProvider")
    public Object process(Object oriValue, CalculatorProvider calculatorProvider) {
        if( !"Test".equals(oriValue) ){
            return oriValue;
        }
        return oriValue + " Demo";
    }

    @Override
    public Object processBeforeToTag(Object oriValue, CellGUIAttr attr, Style style, int height, int width) {
        if( !"Test Demo".equals(oriValue) ){
            return oriValue;
        }
        return oriValue +" Tag";
    }

    private static final int M_HEIGHT = 1;
    private static final int M_WIDTH = 2;

    @Override
    public int prepare2ShrinkRealWidthOrHeight4Cell(CellElement cell, int height, int width, int mode) {
        Object value = cell.getValue();
        if( !"Test Demo".equals(value) ){
            return -1;
        }
        if( M_HEIGHT == mode ){
            return height*2;
        }
        if( M_WIDTH == mode ){
            return width*2;
        }
        return -1;
    }
}
